#!/bin/csh -f

set FNAME = $1
set NFPM = $2
set IBG = $3
set HREJ = $4
set NZ = $5

rm -f group.dat test.one inp.norms nzgroup.dat

echo "1" > test.one

echo "awk @{print $IBG * 52.0 / $NFPM,  $HREJ * 52 / $NFPM, $NZ * 52.0 / $NFPM}@ test.one > inp.norms" > temp0
sed -e 's/@/\'\''/g' temp0 > temp0.go
source temp0.go

set IBG52 = `awk '{print $1}' inp.norms`
set HREJ52 = `awk '{print $2}' inp.norms`
set NZ52 = `awk '{print $3}' inp.norms`

echo "$IBG  0.01" > ibg_min.dat
echo "0" > ibg_min_flag.dat
echo "awk @(yy1 < yy2) {print zz1zz}@ ibg_min.dat > ibg_min_flag.dat" > temp1.go
sed -e 's/@/\'\''/g' temp1.go | sed -e 's/yy/$/g' | sed -e 's/zz/\"/g' > temp_ibg_set.go
source temp_ibg_set.go
set IBG_MIN_FLAG=`awk '{print $1}' ibg_min_flag.dat`

if($IBG_MIN_FLAG == 1) then 
  set IBG=`awk '{print $2}' ibg_min.dat`
endif

echo "awk @(($IBG52 < 0.10) && ($HREJ52 < 0.15)) {print \\11\\}@ test.one >> group.dat" > temp_group.go
echo "awk @(($IBG52 < 0.10) && ($HREJ52 >= 0.15) && ($HREJ52 < 0.40)) {print \\12\\}@ test.one >> group.dat"  >> temp_group.go
echo "awk @(($IBG52 < 0.10) && ($HREJ52 >= 0.40) && ($HREJ52 < 1.00)) {print \\13\\}@ test.one >> group.dat"  >> temp_group.go
echo "awk @(($IBG52 < 0.10) && ($HREJ52 >= 1.00) && ($HREJ52 < 2.00)) {print \\14\\}@ test.one >> group.dat"  >> temp_group.go
echo "awk @(($IBG52 < 0.10) && ($HREJ52 >= 2.00) && ($HREJ52 < 5.00)) {print \\15\\}@ test.one >> group.dat"  >> temp_group.go

echo "awk @(($IBG52 >= 0.10) && ($IBG52 < 0.2) && ($HREJ52 < 0.20)) {print \\21\\}@ test.one >> group.dat"  >> temp_group.go
echo "awk @(($IBG52 >= 0.10) && ($IBG52 < 0.2) && ($HREJ52 >= 0.20) && ($HREJ52 < 0.40)) {print \\22\\}@ test.one >> group.dat"  >> temp_group.go
echo "awk @(($IBG52 >= 0.10) && ($IBG52 < 0.2) && ($HREJ52 >= 0.40) && ($HREJ52 < 1.00)) {print \\23\\}@ test.one >> group.dat"  >> temp_group.go
echo "awk @(($IBG52 >= 0.10) && ($IBG52 < 0.2) && ($HREJ52 >= 1.00) && ($HREJ52 < 2.00)) {print \\24\\}@ test.one >> group.dat"  >> temp_group.go
echo "awk @(($IBG52 >= 0.10) && ($IBG52 < 0.2) && ($HREJ52 >= 2.00) && ($HREJ52 < 5.00)) {print \\25\\}@ test.one >> group.dat"  >> temp_group.go

echo "awk @(($IBG52 >= 0.2) && ($IBG52 < 0.4) && ($HREJ52 < 0.25)) {print \\31\\}@ test.one >> group.dat"  >> temp_group.go
echo "awk @(($IBG52 >= 0.2) && ($IBG52 < 0.4) && ($HREJ52 >= 0.25) && ($HREJ52 < 0.40)) {print \\32\\}@ test.one >> group.dat"  >> temp_group.go
echo "awk @(($IBG52 >= 0.2) && ($IBG52 < 0.4) && ($HREJ52 >= 0.40) && ($HREJ52 < 1.00)) {print \\33\\}@ test.one >> group.dat"  >> temp_group.go
echo "awk @(($IBG52 >= 0.2) && ($IBG52 < 0.4) && ($HREJ52 >= 1.00) && ($HREJ52 < 2.00)) {print \\34\\}@ test.one >> group.dat"  >> temp_group.go
echo "awk @(($IBG52 >= 0.2) && ($IBG52 < 0.4) && ($HREJ52 >= 2.00) && ($HREJ52 < 5.00)) {print \\35\\}@ test.one >> group.dat"  >> temp_group.go

echo "awk @(($IBG52 >= 0.4) && ($IBG52 < 1.0) && ($HREJ52 < 0.13))  {print \\41\\}@ test.one >> group.dat"  >> temp_group.go
echo "awk @(($IBG52 >= 0.4) && ($IBG52 < 1.0) && ($HREJ52 >= 0.13) && ($HREJ52 < 0.40)) {print \\42\\}@ test.one >> group.dat"  >> temp_group.go
echo "awk @(($IBG52 >= 0.4) && ($IBG52 < 1.0) && ($HREJ52 >= 0.40) && ($HREJ52 < 0.90)) {print \\43\\}@ test.one >> group.dat"  >> temp_group.go
echo "awk @(($IBG52 >= 0.4) && ($IBG52 < 1.0) && ($HREJ52 >= 0.90) && ($HREJ52 < 2.00)) {print \\44\\}@ test.one >> group.dat"  >> temp_group.go
echo "awk @(($IBG52 >= 0.4) && ($IBG52 < 1.0) && ($HREJ52 >= 2.00) && ($HREJ52 < 5.00)) {print \\45\\}@ test.one >> group.dat"  >> temp_group.go

echo "awk @(($IBG52 >= 1.0) && ($IBG52 < 3.0) && ($HREJ52 < 0.20)) {print \\51\\}@ test.one >> group.dat"  >> temp_group.go
echo "awk @(($IBG52 >= 1.0) && ($IBG52 < 3.0) && ($HREJ52 >= 0.20) && ($HREJ52 < 0.40)) {print \\52\\}@ test.one >> group.dat"  >> temp_group.go
echo "awk @(($IBG52 >= 1.0) && ($IBG52 < 3.0) && ($HREJ52 >= 0.40) && ($HREJ52 < 0.90)) {print \\53\\}@ test.one >> group.dat"  >> temp_group.go
echo "awk @(($IBG52 >= 1.0) && ($IBG52 < 3.0) && ($HREJ52 >= 0.90) && ($HREJ52 < 2.00)) {print \\54\\}@ test.one >> group.dat"  >> temp_group.go
echo "awk @(($IBG52 >= 1.0) && ($IBG52 < 3.0) && ($HREJ52 >= 2.00) && ($HREJ52 < 5.00)) {print \\55\\}@ test.one >> group.dat"  >> temp_group.go

echo "awk @(($IBG52 >= 3.0) && ($IBG52 <= 10.0) && ($HREJ52 < 0.20)) {print \\61\\}@ test.one >> group.dat"  >> temp_group.go
echo "awk @(($IBG52 >= 3.0) && ($IBG52 <= 10.0) && ($HREJ52 >= 0.20) && ($HREJ52 < 0.55)) {print \\62\\}@ test.one >> group.dat"  >> temp_group.go
echo "awk @(($IBG52 >= 3.0) && ($IBG52 <= 10.0) && ($HREJ52 >= 0.55) && ($HREJ52 < 0.85)) {print \\63\\}@ test.one >> group.dat"  >> temp_group.go
echo "awk @(($IBG52 >= 3.0) && ($IBG52 <= 10.0) && ($HREJ52 >= 0.85) && ($HREJ52 < 2.00)) {print \\64\\}@ test.one >> group.dat"  >> temp_group.go
echo "awk @(($IBG52 >= 3.0) && ($IBG52 <= 10.0) && ($HREJ52 >= 2.00) && ($HREJ52 < 5.00)) {print \\65\\}@ test.one >> group.dat"  >> temp_group.go

sed -e 's/\\\\/"/g' temp_group.go | sed -e 's/@/\'\''/g' > find_group.go

source find_group.go

set GROUPFIND=`wc -l group.dat | awk '{print $1}'`

set GROUP=`awk '{print $1}' group.dat`

###---if Library empty; move in IBG to find the BG shape

if($GROUP == 15) then
  set GROUP=14
endif


if($GROUP == 25) then
  set GROUP=24
endif


if($GROUP == 35) then
  set GROUP=34
endif


if($GROUP == 45) then
  set GROUP=44
endif


if($GROUP == 55) then
  set GROUP=54
endif


if($GROUP == 61) then
  set GROUP=62
endif

set NZGROUP = 20

echo "awk @($NZ52 < 200.0) {print \\00\\}@ test.one >> nzgroup.dat" > temp_nzgroup.go
echo "awk @(($NZ52 >= 200.0) && ($NZ52 < 230.0)) {print \\01\\}@ test.one >> nzgroup.dat"  >> temp_nzgroup.go
echo "awk @(($NZ52 >= 230.0) && ($NZ52 < 280.0)) {print \\02\\}@ test.one >> nzgroup.dat"  >> temp_nzgroup.go
echo "awk @(($NZ52 >= 280.0) && ($NZ52 < 350.0)) {print \\03\\}@ test.one >> nzgroup.dat"  >> temp_nzgroup.go
echo "awk @(($NZ52 >= 350.0) && ($NZ52 < 450.0)) {print \\04\\}@ test.one >> nzgroup.dat"  >> temp_nzgroup.go
echo "awk @(($NZ52 >= 450.0) && ($NZ52 < 560.0)) {print \\05\\}@ test.one >> nzgroup.dat"  >> temp_nzgroup.go
echo "awk @(($NZ52 >= 560.0) && ($NZ52 < 680.0)) {print \\06\\}@ test.one >> nzgroup.dat"  >> temp_nzgroup.go
echo "awk @(($NZ52 >= 680.0) && ($NZ52 < 800.0)) {print \\07\\}@ test.one >> nzgroup.dat"  >> temp_nzgroup.go
echo "awk @(($NZ52 >= 800.0) && ($NZ52 < 1000.0)) {print \\08\\}@ test.one >> nzgroup.dat"  >> temp_nzgroup.go
echo "awk @(($NZ52 >= 1000.0) && ($NZ52 < 1200.0)) {print \\09\\}@ test.one >> nzgroup.dat"  >> temp_nzgroup.go
echo "awk @(($NZ52 >= 1200.0) && ($NZ52 < 1500.0)) {print \\10\\}@ test.one >> nzgroup.dat"  >> temp_nzgroup.go
echo "awk @(($NZ52 >= 1500.0) && ($NZ52 < 2000.0)) {print \\11\\}@ test.one >> nzgroup.dat"   >> temp_nzgroup.go
echo "awk @($NZ52 >= 2000.0) {print \\12\\}@ test.one >> nzgroup.dat"   >> temp_nzgroup.go

sed -e 's/\\\\/"/g' temp_nzgroup.go | sed -e 's/@/\'\''/g' > find_nzgroup.go

source find_nzgroup.go

set NZGROUPFIND=`wc -l nzgroup.dat | awk '{print $1}'`

set NZGROUP=`awk '{printf "%02d", $1}' nzgroup.dat`

if(($GROUPFIND == 1) && ($NZGROUP != "20")) then

  echo "Model 3C50: $FNAME  is in GROUP $GROUP and NZGROUP $NZGROUP"

  echo "grep bg_group_3C50_RGngt_v5_$GROUP.pha bg_group_3C50_RGngt_v5.table > temp_bg3C50_file.dat" > find_bg3C50_lib_spec.go
  echo "grep bg_group_3C50_RGday_v5_$NZGROUP.pha bg_group_3C50_RGday_v5.table > temp_day_noise_file.dat" >> find_bg3C50_lib_spec.go
  source find_bg3C50_lib_spec.go

  set BGNAME=bgsub_$FNAME

  set LIBNAME=`awk '{print $1}' temp_bg3C50_file.dat`
  set LIBSCALE=`awk '{print $2}' temp_bg3C50_file.dat` 

  if($NZGROUP == "00") then  
  echo "mathpha \\$FNAME - ($LIBNAME * $IBG / $LIBSCALE)\\ R outfil=\\$BGNAME\\ exposure=$FNAME errmeth=gaussian properr=yes ncomments=0 areascal=NULL clobber=yes" > temp.math
  endif


  if($NZGROUP != "00") then  
     set LIBNAME2=`awk '{print $1}' temp_day_noise_file.dat`
     set LIBSCALE2=`awk '{print $2}' temp_day_noise_file.dat` 

     echo "mathpha \\$FNAME - ($LIBNAME * $IBG / $LIBSCALE) - ($LIBNAME2 * $NZ / $LIBSCALE2)\\ R outfil=\\$BGNAME\\ exposure=$FNAME errmeth=gaussian properr=yes ncomments=0 areascal=NULL clobber=yes" > temp.math
  endif

  sed -e 's/\\\\/"/g' temp.math | sed -e 's/\.dat/\.pha/g' > calc_bgsub.go

endif


if(($GROUPFIND == 0) || ($NZGROUP == 20)) then

  echo "No BG Model for $FNAME ; IBG52 or HREJ52 or NZ52 beyond library safe limits"

  echo "echo \\spectrum $FNAME :  BG parameters exceed BG Library limits\\" > temp.math

  sed -e 's/\\\\/"/g' temp.math > calc_bgsub.go

endif
